-- SRSmoney
-- by hummel (modhoster)

SrsMoney = {};

function SrsMoney:loadMap(name)
  self.money_amount = 0;
end;

function SrsMoney:keyEvent(unicode, sym, modifier, isDown)
  if bitAND(modifier, Input.MOD_ALT) > 0 and bitAND(modifier, Input.MOD_CTRL) > 0 then
    if InputBinding.isPressed(InputBinding.HONK) then
      self.money_amount = 1000000;
    end
    
    if InputBinding.isPressed(InputBinding.TOGGLE_BEACON_LIGHTS) then
      self.money_amount = -1000000;
    end

    if self.money_amount ~= 0 and g_server == nil then
      g_client:getServerConnection():sendEvent(SrsMoneyEvent:new(self));
    end;
  end;		
end;

function SrsMoney:update(dt)
  if self.money_amount ~= 0 and g_server ~= nil then 
    g_currentMission:addSharedMoney(self.money_amount);
    self.money_amount = 0;
  end;
end;

function SrsMoney:draw()
end;

function SrsMoney:deleteMap()
end;

function SrsMoney:mouseEvent(posX, posY, isDown, isUp, button)
end;

addModEventListener(SrsMoney);

SrsMoneyEvent = {};
SrsMoneyEvent_mt = Class(SrsMoneyEvent, Event);

InitEventClass(SrsMoneyEvent, "SrsMoneyEvent");

function SrsMoneyEvent:readStream(streamId, connection)
  self.object = SrsMoney;
  self.object.money_amount = streamReadInt32(streamId);
end;

function SrsMoneyEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, self.object.money_amount);
end;

function SrsMoneyEvent:new(object)
  local self = SrsMoneyEvent:emptyNew()
  self.object = object;
  return self;
end;

function SrsMoneyEvent:emptyNew()
  local self = Event:new(SrsMoneyEvent_mt);
  self.className="SrsMoneyEvent";
  return self;
end;
